﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Slider_Puzzle
{
    public partial class Form1 : Form
    {
        //CREATES VARIABLES, NOTE TO MYSELF: GO THRU ALL OF THEM TO SEE IF NECCESARY
        bool GameStarted = false;
        int FreeSpace = 16;
        int BlockNum;
        string BlockName;
        string PanelPosX;
        string PanelPosY;
        int[] Pos;
        int Space;
        int TimerVal;
        int RandDirection;
        int Moves;
        int BestMoves;
        int Minutes;
        int Seconds;    
        int Cat; //<<--- Should Probably Be Renamed..
        int Found;
        int OldDirection;
        int ScrambledBlock;
        int Score;
        int BestScore;
        Random rnd = new Random();

        public Form1()
        {
            InitializeComponent();
        }

        //SETS THINGS ON LOAD
        private void Form1_Load(object sender, EventArgs e)
        {
            this.Height = 340;
            Pos = new int[16];
            //Sets Default Pos Of Tiles, Each Pos[] Is Used For The Tiles To Store Its Location
            Pos[1] = 1; // |
            Pos[2] = 2; // |
            Pos[3] = 3; // |
            Pos[4] = 4; // V
            Pos[5] = 5;
            Pos[6] = 6;
            Pos[7] = 7;
            Pos[8] = 8;
            Pos[9] = 9;
            Pos[10] = 10;
            Pos[11] = 11;
            Pos[12] = 12;
            Pos[13] = 13;
            Pos[14] = 14;
            Pos[15] = 15;
            WinPanel.Width = 313;
            WinPanel.Height = 257;
            HighScoresPanel.Width = 313;
            HighScoresPanel.Height = 257;
            //LOADS THE HIGHSCORES FOR BESTMOVES
            BestMoves = Properties.Settings.Default.BestMoves;
            BestMoves1.Text = "Best: " + Convert.ToString(BestMoves);
            //Loads The HighScores
            BestTime1.Text = Properties.Settings.Default.BestTimeString; //Shows "Best Time: " On Screen
            if (BestTime1.Text == "") { BestTime1.Text = "Best: 0: 00"; }
            Score1.Text = Convert.ToString(Properties.Settings.Default.Score1);
            Score2.Text = Convert.ToString(Properties.Settings.Default.Score2);
            Score3.Text = Convert.ToString(Properties.Settings.Default.Score3);
            Score4.Text = Convert.ToString(Properties.Settings.Default.Score4);
            Score5.Text = Convert.ToString(Properties.Settings.Default.Score5);
        }

        //MOVES THE CLICKED TILE
        public void BlockClick()
        {
            try
            {
                if (GameStarted) //Only Move Tile If Game Is Started
                {
                PanelPosX = "panel" + Convert.ToString(FreeSpace); //Sets PanelPosX & Y Which Is Where The Tile Will Be Moved (Previous FreeSpace)
                PanelPosY = "panel" + Convert.ToString(FreeSpace); 

                    //Checks If The Clicked Tile Can Be Moved
                if (FreeSpace - 1 == BlockNum || FreeSpace + 1 == BlockNum || FreeSpace - 4 == BlockNum || FreeSpace + 4 == BlockNum)
                {  //^^ If BlockNum is On Left or ^^ If BlockNum Is On Right or ^^ If BlockNum Is Above or ^^ If BlockNum is Under.

                    this.Controls[string.Format(BlockName)].Top = this.Controls[string.Format(PanelPosX)].Top;
                    this.Controls[string.Format(BlockName)].Left = this.Controls[string.Format(PanelPosY)].Left;

                    //Swaps The Values Of FreeSpace And The Variable Of The Clicked Tile Which Tells Where It Is Located
                    int swap = FreeSpace;
                    FreeSpace = Pos[Space];
                    Pos[Space] = swap;

                    Moves++; //Adds 1 to Moves And Updates The Label
                    MovesLabel1.Text = "Moves: " + Moves;

                    //Checks If You Have Places All Tiles On Their Position (Won)
                    if (Pos[1] == 1 && Pos[2] == 2 && Pos[3] == 3 && Pos[4] == 4 && Pos[5] == 5 && Pos[6] == 6 && Pos[7] == 7 && Pos[8] == 8 && Pos[9] == 9 && Pos[10] == 10 && Pos[11] == 11 && Pos[12] == 12 && Pos[13] == 13 && Pos[14] == 14 && Pos[15] == 15)
                    {
                        WinPanel.Show(); //Shows The "Congratulations" Screen
                        Timer.Stop(); //Stops Counting Time
                        MovesLabel2.Text = "Moves: " + Moves; //Shows Moves On Win Screen
                        TimeLabel2.Text = TimeLabel1.Text;    //Shows Time On Win Screen
                        GameStarted = false; //Can No Longer Move Tiles

                        Seconds = Seconds + (Minutes * 60); //Takes The Seconds Passed And Multiplies It By 2
                        Score = (Seconds * 2) + Moves; //Total Score Is Seconds * 2 + Moves. Lower Is Better.
                        HighScoreCounter(Score); //Runs The HighScore "Counter"
                        TotalScore2.Text = "Total Score: " + Convert.ToString(Score); //Show Total Score On Win Screen

                        if (Moves < BestMoves) //Checks If The HighScore Of Moves Was Beaten
                        {
                            BestMoves = Moves; //Replaces Old BestMoves With New
                            Properties.Settings.Default.BestMoves = BestMoves; //Changes The "BestMoves" Setting To New Best
                            BestMoves1.Text = "Best: " + BestMoves; //Shows New Best Moves On Game Screen
                            Properties.Settings.Default.Save();  //Saves HighScores
                        }

                        //Checks If Best Time Was Beaten
                        if ((Minutes * 60) + Seconds < Properties.Settings.Default.BestTime || Properties.Settings.Default.BestTime == 0)
                        {
                            Properties.Settings.Default.BestTimeString = "Best: " + Minutes + ":" + Seconds; //The String That Is Shown

                            BestTime1.Text = Properties.Settings.Default.BestTimeString; //Shows The String
                            Properties.Settings.Default.BestTime = (Minutes * 60) + Seconds; //Saves Best Time
                            Properties.Settings.Default.Save(); //Saves HighScores
                        }
                        if (Score < BestScore || BestScore == 0)
                        {
                            BestScore = Score; //Replaces Old BestScore With New
                            Properties.Settings.Default.BestScore = BestScore; //Changes The "BestSCore" Setting To New Best
                            Properties.Settings.Default.Save(); //Saves Best Score
                            MessageBox.Show("New HighScore!", "Congratulations!"); //Shows A Popup Saying You Won
                        }
                    }
                 }
              }
            }
            catch (Exception ex){ }
        }

        //HANDLES THE TILES CLICK EVENTS AND SENDS INFORMATION TO BLOCKCLICK()
        private void block1_Click(object sender, EventArgs e){
            Space = 1;  //Used When The Tiles Position Is Swapped With FreeSpace
            BlockNum = Pos[1]; //Position Of Tile
            BlockName = "block1"; //Used When The Tile Is Moved
            BlockClick();} //Calls BlockClick
        private void block2_Click(object sender, EventArgs e){
            Space = 2;
            BlockNum = Pos[2];
            BlockName = "block2";
            BlockClick();}
        private void block3_Click(object sender, EventArgs e){
            Space = 3;
            BlockNum = Pos[3];
            BlockName = "block3";
            BlockClick();}
        private void block4_Click(object sender, EventArgs e){
            Space = 4;
            BlockNum = Pos[4];
            BlockName = "block4";
            BlockClick();}
        private void block5_Click(object sender, EventArgs e){
            Space = 5;
            BlockNum = Pos[5];
            BlockName = "block5";
            BlockClick();}
        private void block6_Click(object sender, EventArgs e){
            Space = 6;
            BlockNum = Pos[6];
            BlockName = "block6";
            BlockClick(); }
        private void block7_Click(object sender, EventArgs e){
            Space = 7;
            BlockNum = Pos[7];
            BlockName = "block7";
            BlockClick();}
        private void block8_Click(object sender, EventArgs e){
            Space = 8;
            BlockNum = Pos[8];
            BlockName = "block8";
            BlockClick();}
        private void block9_Click(object sender, EventArgs e){
            Space = 9;
            BlockNum = Pos[9];
            BlockName = "block9";
            BlockClick();}
        private void block10_Click(object sender, EventArgs e){
            Space = 10;
            BlockNum = Pos[10];
            BlockName = "block10";
            BlockClick();}
        private void block11_Click(object sender, EventArgs e){
            Space = 11;
            BlockNum = Pos[11];
            BlockName = "block11";
            BlockClick();}
        private void block12_Click(object sender, EventArgs e){
            Space = 12;
            BlockNum = Pos[12];
            BlockName = "block12";
            BlockClick();}
        private void block13_Click(object sender, EventArgs e){
            Space = 13;
            BlockNum = Pos[13];
            BlockName = "block13";
            BlockClick();}
        private void block14_Click(object sender, EventArgs e){
            Space = 14;
            BlockNum = Pos[14];
            BlockName = "block14";
            BlockClick();}
        private void block15_Click(object sender, EventArgs e){
            Space = 15;
            BlockNum = Pos[15];
            BlockName = "block15";
            BlockClick();}

        private void ScrambleTimer_Tick(object sender, EventArgs e) //The Timer That Scrambles The Tiles
        {
            try
            {
                RandDirection = Randomizer(); //Gets A new Random Direction 1 = Up 2 = Right 3 = Down 4 = Left


                //If Direction Is Up.   Skips If FreeSpace is At The Top
                if (RandDirection == 1 && FreeSpace != 1 && FreeSpace != 2 && FreeSpace != 3 && FreeSpace != 4)
                {
                    Cat = FreeSpace - 4;
                    ScrambleMover();
                }
                //If Direction Is Right.  Skips If FreeSpace Is On The Right
                if (RandDirection == 2 && FreeSpace != 4 && FreeSpace != 8 && FreeSpace != 12 && FreeSpace != 16)
                {
                    Cat = FreeSpace + 1;
                    ScrambleMover();
                }
                //If Direction Is Down.  Skips If FreeSpace Is On The Bottom
                if (RandDirection == 3 && FreeSpace != 13 && FreeSpace != 14 && FreeSpace != 15 && FreeSpace != 16)
                {
                    Cat = FreeSpace + 4;
                    ScrambleMover();
                }
                //If Direction Is Left.  Skip If FreeSpace Is On The Left
                if (RandDirection == 4 && FreeSpace != 1 && FreeSpace != 2 && FreeSpace != 3 && FreeSpace != 4)
                {
                    Cat = FreeSpace - 1;
                    ScrambleMover();
                }

                    OldDirection = RandDirection;
                    ScrambledBlock = Found;
                
                //If The Timer Has Ticked 200 Times It Stops And Starts The Game
                if (TimerVal == 200)
                {
                    TimerVal = 0; //Resets Timer
                    ProgressBar.Value = 0; //Resets
                    ProgressBar.Visible = false; //Hide ProgressBar
                    ProgressLabel.Visible = false;
                    this.Height = 340;
                    GameStarted = true; //Make The User Able To Move The Tiles
                    Timer.Start(); //Starts Counting Time
                    ScrambleTimer.Stop(); //Stops Scrambling
                }
                TimerVal++; //Adds 1 To TimerVal Each Time The Timer Ticks

                ProgressBar.Value = TimerVal; //Update The ProgressBar
            }
            catch (Exception ex)
            {
            }
        }

        //MOVES THE TILES IN THE SCRAMBLER
        //CALLED FROM SCRAMBLETIMER
        private void ScrambleMover()
        {
            if (Pos[1] == Cat) { Found = 1; } //Detects Which Tile Will Be Moved
            if (Pos[2] == Cat) { Found = 2; } // |
            if (Pos[3] == Cat) { Found = 3; } // |
            if (Pos[4] == Cat) { Found = 4; } // |
            if (Pos[5] == Cat) { Found = 5; } // V
            if (Pos[6] == Cat) { Found = 6; }
            if (Pos[7] == Cat) { Found = 7; }
            if (Pos[8] == Cat) { Found = 8; }
            if (Pos[9] == Cat) { Found = 9; }
            if (Pos[10] == Cat) { Found = 10; }
            if (Pos[11] == Cat) { Found = 11; }
            if (Pos[12] == Cat) { Found = 12; }
            if (Pos[13] == Cat) { Found = 13; }
            if (Pos[14] == Cat) { Found = 14; }
            if (Pos[15] == Cat) { Found = 15; }


            //Moves The Tile
            this.Controls[string.Format("block" + Found)].Top = this.Controls[string.Format("panel" + FreeSpace)].Top; //Y Coord
            this.Controls[string.Format("block" + Found)].Left = this.Controls[string.Format("panel" + FreeSpace)].Left; //X Coord

            //Swaps The Values Of FreeSpace And The Variable Of The Moved Block That Tells Where It Is Located
            int swap = FreeSpace;
            FreeSpace = Cat;
            Pos[Found] = swap;
        }
        //RETURNS A RANDOM NUMBER BETWEEN ONE AND FOUR
        //USED IN THE SCRAMBLER. 1 = UP 2 = RIGHT 3 = DOWN 4 = LEFT
        protected int Randomizer()
        {
            return rnd.Next(1, 5);
        }
        protected int SecondRandomizer()
        {
            return rnd.Next(1, 3);
        }

        //STARTBUTTON (Starts The Scrambler And Resets Stuff)
        private void button1_Click(object sender, EventArgs e)
        {
            GameStarted = false;
            ScrambleTimer.Start(); //Start The Scrambler
            this.Height = 378; //Make Form Height Lower, Because It Looks Weird With The Empty Space When The ProgressBar Is Hidden..
            ProgressBar.Visible = true; //Hides The ProgressBar
            ProgressLabel.Visible = true; // And Its Label
            Minutes = 0; //Resets Minutes
            Seconds = 0; //And The Seconds
            TimeLabel1.Text = "Time: 0:00"; //And The Time's Text
            MovesLabel1.Text = "Moves: 0"; //And The Moves Text
            Timer.Stop(); //Stops Adding Time
        }

        //NEW GAME (If User Won)
        private void button2_Click(object sender, EventArgs e)
        {
            GameStarted = false;
            WinPanel.Hide(); //Hide The Win Panel
            Moves = 0; //Resets Moves
            MovesLabel1.Text = "Moves: 0"; //And The Moves Label
            MovesLabel2.Text = "Moves: 0"; //Etc
            TimeLabel1.Text = "Time: 0: 00"; //Etc
        }

        //THE TIMER (Shows How Long You Have Played)
        private void Timer_Tick(object sender, EventArgs e)
        {
            string Sec2;
            Seconds = Seconds + 1; //Adds One Second Each Tick (Interval: 1000ms)

            if (Seconds < 10) //If Seconds Is Less Than 10, It Shows A Zero To Make It Look Better
            {
                Sec2 = "0";
            }
            else
            {
                Sec2 = "";
            }
            TimeLabel1.Text = "Time: " + Minutes + ":" + Sec2 + Seconds; //Sets The Time Label To The Time

            if (Seconds == 59) //If One Minute Has Passed; 1 Is Added To Minutes And Seconds Is Set to 0
            {
                Seconds = 0;
                Minutes++;
            }
        }

        private void button3_Click(object sender, EventArgs e) 
        {
            HighScoresPanel.Visible = true; //Show HighScore List
        }

        private void BackToWinButton_Click(object sender, EventArgs e) 
        {
            HighScoresPanel.Visible = false; //Back To Win Screen
        }

        private void HighScoreCounter(int NewScore) //THE HIGHSCORE LIST
        {
            try
            {
                int[] Swap = new int[5];

                if (NewScore < Convert.ToInt32(Score1.Text) || Convert.ToInt32(Score1.Text) == 0) //If NewScore Is Higher Than #1
                {
                    Swap[1] = Convert.ToInt32(Score1.Text);      //Swap[1] = Old Score1.Text
                    Score1.Text = Convert.ToString(NewScore);    //Score1.Text = NewScore
                    Swap[2] = Convert.ToInt32(Score2.Text);  //Swap[2] Old Score2.Text
                    Score2.Text = Convert.ToString(Swap[1]); //Score2.Text = Prev Score1.Text
                    Swap[3] = Convert.ToInt32(Score3.Text);  //Swap[3] = Old Score3.Text
                    Score3.Text = Convert.ToString(Swap[2]); //score3.Text = Prev Score2.Text
                    Swap[4] = Convert.ToInt32(Score4.Text);  //Swap[4] = Old Score4.Text
                    Score4.Text = Convert.ToString(Swap[3]); //Score4.Text = Prev Score3.Text
                    Score5.Text = Convert.ToString(Swap[4]); //Score5.Text = Prev Score4.Text
                }
                else

                    if (NewScore < Convert.ToInt32(Score2.Text) || Convert.ToInt32(Score2.Text) == 0) //If NewScore Is Higher Than #2
                    {
                        Swap[1] = Convert.ToInt32(Score2.Text);   //Swap[1] = Old Score2.Text
                        Score2.Text = Convert.ToString(NewScore); //Score2.Text = NewScore
                        Swap[2] = Convert.ToInt32(Score3.Text);   //Swap[2] = Old Score3.Text
                        Score3.Text = Convert.ToString(Swap[1]);  //score3.Text = Old Score2.Text
                        Swap[3] = Convert.ToInt32(Score4.Text);  //Swap[3] = Old Score4.Text
                        Score4.Text = Convert.ToString(Swap[2]);  //Score4.Text = Old Score3.Text
                        Score5.Text = Convert.ToString(Swap[3]);  //Score5.Text = Old Score4.Text
                    }
                    else
                        if (NewScore < Convert.ToInt32(Score3.Text) || Convert.ToInt32(Score3.Text) == 0) //If NewScore Is Higher Than #3
                        {
                            Swap[1] = Convert.ToInt32(Score3.Text);   //Swap[1] = Old Score3.Text
                            Score3.Text = Convert.ToString(NewScore); //Score3.Text = NewScore
                            Swap[2] = Convert.ToInt32(Score4.Text);   //Swap[2] = Old Score4.Text
                            Score4.Text = Convert.ToString(Swap[1]);  //Score4.Text = Old Score3.Text
                            Score5.Text = Convert.ToString(Swap[2]);  //Score5.Text = Old Score4.Text
                        }
                        else
                            if (NewScore < Convert.ToInt32(Score4.Text) || Convert.ToInt32(Score4.Text) == 0) //If NewScore Is Higher Than #4
                            {
                                Swap[1] = Convert.ToInt32(Score4.Text);   //Swap[1] = Old Score4.Text
                                Score4.Text = Convert.ToString(NewScore); //Score4.Text = NewScore
                                Score5.Text = Convert.ToString(Swap[1]);  //Score5.Text = Prev Score4.Text
                            }
                            else
                                if (NewScore < Convert.ToInt32(Score5.Text) || Convert.ToInt32(Score5.Text) == 0) //If NewScore Is Higher Than #5
                                {
                                    Swap[1] = Convert.ToInt32(Score5.Text);
                                    Score5.Text = Convert.ToString(NewScore); //Score5.Text = NewScore
                                }

                //Saves The HighScores
                Properties.Settings.Default.Score1 = Convert.ToInt32(Score1.Text);
                Properties.Settings.Default.Score2 = Convert.ToInt32(Score2.Text);
                Properties.Settings.Default.Score3 = Convert.ToInt32(Score3.Text);
                Properties.Settings.Default.Score4 = Convert.ToInt32(Score4.Text);
                Properties.Settings.Default.Score5 = Convert.ToInt32(Score5.Text);

                Properties.Settings.Default.Save();
            }
            catch (Exception ex)
            {
            }
        }

        //Show High Scores Menu
        private void button3_Click_1(object sender, EventArgs e)
        {
            HighScoresPanel.Visible = true;
        }
    }
}